--- /dev/null	Sat May 10 12:09:55 2014
+++ new/usr/src/lib/libmvec/common/mapfile-vers	Sat May 10 12:09:55 2014
@@ -0,0 +1,146 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+# Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+#
+# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+# Interface definition for libmvec.so.1
+
+$mapfile_version 2
+
+$if _ELF32
+$add lf64
+$endif
+$if _sparc && _ELF32
+$add sparc32
+$endif
+$if _sparc && _ELF64
+$add sparcv9
+$endif
+$if _x86 && _ELF32
+$add i386
+$endif
+$if _x86 && _ELF64
+$add amd64
+$endif
+
+SYMBOL_VERSION SUNW_1.1 {
+	global:
+		__vatan2;		#LSARC/2003/737
+		__vatan2_;		#LSARC/2003/737
+		__vatan2f;		#LSARC/2003/737
+		__vatan2f_;		#LSARC/2003/737
+		__vatan;		#LSARC/2003/737
+		__vatan_;		#LSARC/2003/737
+		__vatanf;		#LSARC/2003/737
+		__vatanf_;		#LSARC/2003/737
+		__vc_abs;		#LSARC/2003/737
+		__vc_abs_;		#LSARC/2003/737
+		__vc_exp;		#LSARC/2003/737
+		__vc_exp_;		#LSARC/2003/737
+		__vc_log;		#LSARC/2003/737
+		__vc_log_;		#LSARC/2003/737
+		__vc_pow;		#LSARC/2003/737
+		__vc_pow_;		#LSARC/2003/737
+		__vcos;			#LSARC/2003/737
+		__vcos_;		#LSARC/2003/737
+		__vcosf;		#LSARC/2003/737
+		__vcosf_;		#LSARC/2003/737
+		__vexp;			#LSARC/2003/737
+		__vexp_;		#LSARC/2003/737
+		__vexpf;		#LSARC/2003/737
+		__vexpf_;		#LSARC/2003/737
+		__vhypot;		#LSARC/2003/737
+		__vhypot_;		#LSARC/2003/737
+		__vhypotf;		#LSARC/2003/737
+		__vhypotf_;		#LSARC/2003/737
+		__vlog;			#LSARC/2003/737
+		__vlog_;		#LSARC/2003/737
+		__vlogf;		#LSARC/2003/737
+		__vlogf_;		#LSARC/2003/737
+		__vpow;			#LSARC/2003/737
+		__vpow_;		#LSARC/2003/737
+		__vpowf;		#LSARC/2003/737
+		__vpowf_;		#LSARC/2003/737
+		__vrhypot;		#LSARC/2003/737
+		__vrhypot_;		#LSARC/2003/737
+		__vrhypotf;		#LSARC/2003/737
+		__vrhypotf_;		#LSARC/2003/737
+		__vrsqrt;		#LSARC/2003/737
+		__vrsqrt_;		#LSARC/2003/737
+		__vrsqrtf;		#LSARC/2003/737
+		__vrsqrtf_;		#LSARC/2003/737
+		__vsin;			#LSARC/2003/737
+		__vsin_;		#LSARC/2003/737
+		__vsincos;		#LSARC/2003/737
+		__vsincos_;		#LSARC/2003/737
+		__vsincosf;		#LSARC/2003/737
+		__vsincosf_;		#LSARC/2003/737
+		__vsinf;		#LSARC/2003/737
+		__vsinf_;		#LSARC/2003/737
+		__vsqrt;		#LSARC/2003/737
+		__vsqrt_;		#LSARC/2003/737
+		__vsqrtf;		#LSARC/2003/737
+		__vsqrtf_;		#LSARC/2003/737
+		__vz_abs;		#LSARC/2003/737
+		__vz_abs_;		#LSARC/2003/737
+		__vz_exp;		#LSARC/2003/737
+		__vz_exp_;		#LSARC/2003/737
+		__vz_log;		#LSARC/2003/737
+		__vz_log_;		#LSARC/2003/737
+		__vz_pow;		#LSARC/2003/737
+		__vz_pow_;		#LSARC/2003/737
+		vatan2_;		#LSARC/2003/737
+		vatan2f_;		#LSARC/2003/737
+		vatan_;			#LSARC/2003/737
+		vatanf_;		#LSARC/2003/737
+		vc_abs_;		#LSARC/2003/737
+		vc_exp_;		#LSARC/2003/737
+		vc_log_;		#LSARC/2003/737
+		vc_pow_;		#LSARC/2003/737
+		vcos_;			#LSARC/2003/737
+		vcosf_;			#LSARC/2003/737
+		vexp_;			#LSARC/2003/737
+		vexpf_;			#LSARC/2003/737
+		vhypot_;		#LSARC/2003/737
+		vhypotf_;		#LSARC/2003/737
+		vlog_;			#LSARC/2003/737
+		vlogf_;			#LSARC/2003/737
+		vpow_;			#LSARC/2003/737
+		vpowf_;			#LSARC/2003/737
+		vrhypot_;		#LSARC/2003/737
+		vrhypotf_;		#LSARC/2003/737
+		vrsqrt_;		#LSARC/2003/737
+		vrsqrtf_;		#LSARC/2003/737
+		vsin_;			#LSARC/2003/737
+		vsincos_;		#LSARC/2003/737
+		vsincosf_;		#LSARC/2003/737
+		vsinf_;			#LSARC/2003/737
+		vsqrt_;			#LSARC/2003/737
+		vsqrtf_;		#LSARC/2003/737
+		vz_abs_;		#LSARC/2003/737
+		vz_exp_;		#LSARC/2003/737
+		vz_log_;		#LSARC/2003/737
+		vz_pow_;		#LSARC/2003/737
+	local:
+		*;
+};